// One can evaluate the distance between 2 series, either from a single DataSeries, pointing at two entries, or comparing two buffers

//1. execute the codeblock below
(
~xypoint = Buffer.alloc(s,2);
~entry = FluidDataSet(s);
~gestureXY = Buffer(s);
~count = 0;
~series = FluidDataSeries(s);
~points = FluidDataSet(s);
~dtw = FluidDTW(s);

SynthDef(\writer, {var trig = Impulse.kr(50); FluidDataSetWr.kr(~entry, buf: ~xypoint, idNumber: PulseCount.kr(trig),trig:trig)}).send;

w = Window("LSTMForecaster", Rect(top: Window.screenBounds.height-400, width: 1002,height: 400)).front;

FluidPlotter(w, Rect(width: 400, height: 400), standalone: false, mouseMoveAction: {|...in|
	if (in[5].notNil, {
		//clear the ds
		~entry.clear;
		in[0].dict = Dictionary.newFrom(["cols",2,"data",Dictionary.newFrom([])]);
		//write the value to buf
		~xypoint.setn(0,in[[1,2]]);
		//start the writer function that has a constant frequency
		~timedWriter = Synth(\writer);
	}, {
		if (in[4].notNil, {
			//stop the writer function
			~timedWriter.free;
			//transfer to buf
			~entry.toBuffer(~gestureXY,action: {
				//make an entry in the FluidDataSeries with a given identifier
				~series.setSeries(\left, ~gestureXY);
			});
		}, {
			~xypoint.setn(0,in[[1,2]]);
			in[0].addPoint_(~count.asSymbol,in[1],in[2]);
			~count = ~count + 1;
		});
	});
});

FluidPlotter(w, Rect(left:402, width: 400, height: 400), standalone: false, mouseMoveAction: {|...in|
	if (in[5].notNil, {
		//clear the ds
		~entry.clear;
		in[0].dict = Dictionary.newFrom(["cols",2,"data",Dictionary.newFrom([])]);
		//write the value to buf
		~xypoint.setn(0,in[[1,2]]);
		//start the writer function that has a constant frequency
		~timedWriter = Synth(\writer);
	}, {
		if (in[4].notNil, {
			//stop the writer function
			~timedWriter.free;
			//transfer to buf
			~entry.toBuffer(~gestureXY,action: {
				//make an entry in the FluidDataSeries with a given identifier
				~series.setSeries(\right, ~gestureXY, {
					~dtw.cost(~series, \left, \right, {|x|{~tf.string_(x)}.defer;})
				});
			});
		}, {
			~xypoint.setn(0,in[[1,2]]);
			in[0].addPoint_(~count.asSymbol,in[1],in[2]);
			~count = ~count + 1;
		});
	});
});

StaticText(w, Rect(814,10,150,30)).string_("constraint:");
PopUpMenu(w, Rect(814,40,150,30)).items_(["unconstrained","ikatura","sakoe-chiba"]).action_{|x|~dtw.constraint = x.value; ~dtw.cost(~series, \left, \right, {|x|{~tf.string_(x)}.defer;})};
StaticText(w, Rect(814,70,150,30)).string_("constraint parameter:");
TextField(w, Rect(814,100,150,30)).string_("0").action_{|x|~dtw.constraintParam = x.value.asFloat;~dtw.cost(~series, \left, \right, {|x|{~tf.string_(x)}.defer;})
};
StaticText(w, Rect(814,130,150,30)).string_("cost:");
~tf = TextField(w, Rect(814,160,150,30));
)


// 2. draw a gesture on the left
// 3. draw a gesture on the right
// observe the distance
// you can redraw and change the parameters to explore

