// a forecaster is training on dataseries, trying to predict their shape/future/next states. it is a sort of windowed autoencoder

//1. execute the codeblock below
(
~xypoint = Buffer.alloc(s,2);
~pointOut = Buffer(s);
~entry = FluidDataSet(s);
~gestureXY = Buffer(s);
~count = 0;
~series = FluidDataSeries(s);
~points = FluidDataSet(s);
~lstmf = FluidLSTMForecaster(s,[15, 5, 15],50);
~makingEntries = true;

SynthDef(\writer, {var trig = Impulse.kr(50); FluidDataSetWr.kr(~entry, buf: ~xypoint, idNumber: PulseCount.kr(trig),trig:trig)}).send;

w = Window("LSTMForecaster", Rect(top: Window.screenBounds.height-400, width: 800,height: 400)).front;

Button(w, Rect(410, 280, 100, 20)).states_([[\makingEntry],[\querying]]).action_{|x|~makingEntries = x.value == 0};

Button(w, Rect(410, 310, 100, 20)).states_([["press to fit"],["stop fitting"]]).action_{
	|x|switch (x.value,
		0, {~keeponfitting.stop},
		1, {~keeponfitting = Routine{var cond = Condition.new();
			~lstmf.fit(~series,{|x|{~error.string_(" %".format(x))}.defer; cond.unhang;});
			cond.hang;
}.loop.play;})};

~error = TextView(w,Rect(530,310,100,20)).string_(\unfitted).editable_(false);

Button(w, Rect(650, 310, 100, 20)).states_([["press to reseed"]]).action_{~lstmf.clear; ~error.string_(\unfitted)};

StaticText(w, Rect(410,340,200,20)).string_("hiddenLayers:");

TextField(w,Rect(530,340,100,20)).string_("[15,5,15]").action_{|x|~lstmf.hiddenLayers = x.value.asArray; ~error.string_(\unfitted)};

StaticText(w, Rect(410,370,200,20)).string_("forecastLength:");

TextField(w,Rect(530,370,100,20)).string_("0").action_{|x|~lstmf.forecastLength = x.value.asFloat;};

~fp = FluidPlotter(w, Rect(width: 400, height: 400), standalone: false, mouseMoveAction: {|...in|
	if (in[5].notNil, {
		//clear the ds
		~entry.clear;
		in[0].dict = Dictionary.newFrom(["cols",2,"data",Dictionary.newFrom([])]);
		//write the value to buf
		~xypoint.setn(0,in[[1,2]]);
		//start the writer function that has a constant frequency
		~timedWriter = Synth(\writer);
	}, {
		if (in[4].notNil, {
			//stop the writer function
			~timedWriter.free;
			//transfer to buf
			~entry.toBuffer(~gestureXY,action: {
				if (~makingEntries, {
					//make an entry in the FluidDataSeries with a given identifier
					~series.addSeries(~count.asSymbol, ~gestureXY);
				},{
					~lstmf.predictSeries(~gestureXY, ~pointOut, action: {
						~pointOut.getToFloatArray(action:{
							arg prediction;
							defer{
								prediction.clump(2).do{|point,idx|
									~fp.addPoint_("p%".format(idx),point[0],point[1],Color(1));
								};
							}
						});
					});
				});
			});
		}, {
			~xypoint.setn(0,in[[1,2]]);
			in[0].addPoint_(~count.asSymbol,in[1],in[2]);
			~count = ~count + 1;
		});
	});
})
)
// 2. draw 5 instances of the same gesture, like drawing a circle
// 3. switch to query
// 4. fit
// 5. draw the first half of the circle gesture: magic!
// 6. by default forecaster returns a prediction of the same lenght as the input - you can ask for more or less